Index: branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6966)
+++ branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 7178)
@@ -808,4 +808,41 @@
        <field id="NH4_E3T"      long_name="NH4 * E3T"                                unit="mmol/m2"  > NH4 * e3t </field >
 
+       <!-- PISCES with Quota parama -->
+       <field id="DON"          long_name="Dissolved organic N Concentration"        unit="mmol/m3" />
+       <field id="DON_E3T"      long_name="DON * E3T"                                unit="mmol/m2"  > DON * e3t </field >
+       <field id="DOP"          long_name="Dissolved organic P Concentration"        unit="mmol/m3" />
+       <field id="DOP_E3T"      long_name="DOP * E3T"                                unit="mmol/m2"  > DOP * e3t </field >
+       <field id="PON"          long_name="Small PON Concentration"                  unit="mmol/m3" />
+       <field id="PON_E3T"      long_name="PON * E3T"                                unit="mmol/m2"  > PON * e3t </field >
+       <field id="POP"          long_name="Small POP Concentration"                  unit="mmol/m3" />
+       <field id="POP_E3T"      long_name="POP * E3T"                                unit="mmol/m2"  > POP * e3t </field >
+       <field id="GON"          long_name="Big PON Concentration"                    unit="mmol/m3" />
+       <field id="GON_E3T"      long_name="GON * E3T"                                unit="mmol/m2"  > GON * e3t </field >
+       <field id="GOP"          long_name="Big POP Concentration"                    unit="mmol/m3" />
+       <field id="GOP_E3T"      long_name="GOP * E3T"                                unit="mmol/m2"  > GOP * e3t </field >
+       <field id="PHYN"         long_name="Nanophytoplankton N biomass"              unit="mmol/m3" />
+       <field id="PHYN_E3T"     long_name="PHYN * E3T"                               unit="mmol/m2"  > PHYN * e3t </field >
+       <field id="PHYP"         long_name="Nanophytoplankton P biomass"              unit="mmol/m3" />
+       <field id="PHYP_E3T"     long_name="PHYP * E3T"                               unit="mmol/m2"  > PHYP * e3t </field >
+       <field id="DIAN"         long_name="Diatoms N biomass"                        unit="mmol/m3" />
+       <field id="DIAN_E3T"     long_name="DIAN * E3T"                               unit="mmol/m2"  > DIAN * e3t </field >
+       <field id="DIAP"         long_name="Diatoms P biomass"                        unit="mmol/m3" />
+       <field id="DIAP_E3T"     long_name="DIAP * E3T"                               unit="mmol/m2"  > DIAP * e3t </field >
+       <field id="PIC"          long_name="Picophytoplankton C biomass"              unit="mmol/m3" />
+       <field id="PIC_E3T"      long_name="PIC * E3T"                                unit="mmol/m2"  > PIC * e3t </field >
+       <field id="PICN"         long_name="Picophytoplankton N biomass"              unit="mmol/m3" />
+       <field id="PICN_E3T"     long_name="PICN * E3T"                               unit="mmol/m2"  > PICN * e3t </field >
+       <field id="PICP"         long_name="Picophytoplankton P biomass"              unit="mmol/m3" />
+       <field id="PICP_E3T"     long_name="PICP * E3T"                               unit="mmol/m2"  > PICP * e3t </field >
+       <field id="PFe"          long_name="Picophytoplankton Fe biomass"             unit="mmol/m3" />
+       <field id="PFe_E3T"      long_name="PFe * E3T"                                unit="mmol/m2"  > PFe * e3t </field >
+       <field id="PCHL"         long_name="Picophytoplankton Chl biomass"            unit="mg/m3" />
+       <field id="PCHL_E3T"     long_name="PCHL * E3T"                               unit="mmol/m2"  > PCHL * e3t </field >
+
+       <!-- PISCES with ligand parametisation : variables available with key_ligand -->
+       <field id="LGW"     long_name="Weak ligands concentration"                unit="mmol/m3" />
+       <field id="LFe"     long_name="Lithogenic iron concentration"             unit="mmol/m3" />
+
+
        <!-- PISCES with Kriest parametisation : variables available with key_kriest -->
        <field id="Num"         long_name="Number of organic particles"              unit="1" />
@@ -835,9 +872,12 @@
        <field id="PARDM"       long_name="Daily mean PAR"                          unit="W/m2"       grid_ref="grid_T_3D" />
        <field id="PPPHY"       long_name="Primary production of nanophyto"         unit="mol/m3/s"   grid_ref="grid_T_3D" />
+       <field id="PPPHYP"       long_name="Primary production of picophyto"         unit="molC/m3/s"  grid_ref="grid_T_3D" />
        <field id="PPPHY2"      long_name="Primary production of diatoms"           unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="PPNEWN"      long_name="New Primary production of nanophyto"     unit="mol/m3/s"   grid_ref="grid_T_3D" />
+       <field id="PPNEWP"      long_name="New Primary production of picophyto"     unit="molC/m3/s"  grid_ref="grid_T_3D" />
        <field id="PPNEWD"      long_name="New Primary production of diatoms"       unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="PBSi"        long_name="Primary production of Si diatoms"        unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="PFeN"        long_name="Primary production of nano iron"         unit="mol/m3/s"   grid_ref="grid_T_3D" />
+       <field id="PFeP"        long_name="Primary production of pico iron"         unit="molFe/m3/s" grid_ref="grid_T_3D" />
        <field id="PFeD"        long_name="Primary production of diatoms iron"      unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="xfracal"     long_name="Calcifying fraction"                     unit="1"          grid_ref="grid_T_3D" />
@@ -848,14 +888,26 @@
        <field id="REMIN"       long_name="Oxic remineralization of OM"             unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="DENIT"       long_name="Anoxic remineralization of OM"           unit="mol/m3/s"   grid_ref="grid_T_3D" />
+       <field id="REMINP"       long_name="Oxic remineralization rate of POC"     unit="-/d"  grid_ref="grid_T_3D" />
+       <field id="REMING"       long_name="Oxic remineralization rate of GOC"     unit="-/d"  grid_ref="grid_T_3D" />
        <field id="Nfix"        long_name="Nitrogen fixation"                       unit="mol/m3/s"   grid_ref="grid_T_3D" />
        <field id="Mumax"       long_name="Maximum growth rate"                     unit="s-1"        grid_ref="grid_T_3D" />
        <field id="MuN"         long_name="Realized growth rate for nanophyto"      unit="s-1"        grid_ref="grid_T_3D" />
+       <field id="MuP"         long_name="Realized growth rate for picophyto"      unit="s-1"        grid_ref="grid_T_3D" />
        <field id="MuD"         long_name="Realized growth rate for diatomes"       unit="s-1"        grid_ref="grid_T_3D" />
+       <field id="MunetN"      long_name="Net growth rate for nanophyto"           unit="s-1"        grid_ref="grid_T_3D" />
+       <field id="MunetP"      long_name="Net growth rate for picophyto"           unit="s-1"        grid_ref="grid_T_3D" />
+       <field id="MunetD"      long_name="Net growth rate for diatomes"            unit="s-1"        grid_ref="grid_T_3D" />
        <field id="LNnut"       long_name="Nutrient limitation term in Nanophyto"   unit=""           grid_ref="grid_T_3D" />
+       <field id="LPnut"       long_name="Nutrient limitation term in Picophyto"   unit="-"          grid_ref="grid_T_3D" />
        <field id="LDnut"       long_name="Nutrient limitation term in Diatoms"     unit=""           grid_ref="grid_T_3D" />
        <field id="LNFe"        long_name="Iron limitation term in Nanophyto"       unit=""           grid_ref="grid_T_3D" />
+       <field id="LPFe"        long_name="Iron limitation term in Picophyto"       unit="-"          grid_ref="grid_T_3D" />
        <field id="LDFe"        long_name="Iron limitation term in Diatoms"         unit=""           grid_ref="grid_T_3D" />
        <field id="LNlight"     long_name="Light limitation term in Nanophyto"      unit=""           grid_ref="grid_T_3D" />
+       <field id="LPlight"     long_name="Light limitation term in Picophyto"      unit="-"          grid_ref="grid_T_3D" />
        <field id="LDlight"     long_name="Light limitation term in Diatoms"        unit=""           grid_ref="grid_T_3D" />
+       <field id="SIZEN"       long_name="Mean relative size of nanophyto."        unit="-"          grid_ref="grid_T_3D" />
+       <field id="SIZEP"       long_name="Mean relative size of picophyto."        unit="-"          grid_ref="grid_T_3D" />
+       <field id="SIZED"       long_name="Mean relative size of diatoms"           unit="-"          grid_ref="grid_T_3D" />
        <field id="Fe2"         long_name="Iron II concentration"                   unit="nmol/m3"    grid_ref="grid_T_3D" />
        <field id="Fe3"         long_name="Iron III concentration"                  unit="nmol/m3"    grid_ref="grid_T_3D" />
Index: branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref
===================================================================
--- branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 6966)
+++ branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/namelist_pisces_ref	(revision 7178)
@@ -29,18 +29,26 @@
 !              !              !  (if <0  months)  !   name    !   (logical)  !  (T/F) ! 'monthly' ! filename ! pairing  ! filename      !
    sn_patm     = 'presatm'    ,     -1            , 'patm'    ,  .true.      , .true. , 'yearly'  , ''       , ''       , ''
+   sn_atmco2   = 'presatmco2_reg' , -1            , 'xco2'    ,  .true.      , .true. , 'yearly'  , 'weights_AIRS_bilinear.nc'       , ''       , ''
    cn_dir      = './'     !  root directory for the location of the dynamical files
 !
    ln_presatm  = .false.   ! constant atmopsheric pressure (F) or from a file (T)
+   ln_presatmco2= .false.   ! Read spatialized atm co2 files [ppm] if TRUE
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 &nampisbio     !   biological parameters
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-   nrdttrc    =  1        ! time step frequency for biology
+   nrdttrc    =  3        ! time step frequency for biology
    wsbio      =  2.       ! POC sinking speed
-   xkmort     =  2.E-7    ! half saturation constant for mortality
+   xkmort     =  1.E-7    ! half saturation constant for mortality
    ferat3     =  10.E-6   ! Fe/C in zooplankton 
-   wsbio2     =  30.      ! Big particles sinking speed
+   wsbio2     =  50.      ! Big particles sinking speed
+   wsbio2max  =  50.      ! Big particles maximum sinking speed
+   wsbio2scale=  5000.    ! Big particles length scale of sinking
    niter1max  =  1        ! Maximum number of iterations for POC
-   niter2max  =  1        ! Maximum number of iterations for GOC
+   niter2max  =  2        ! Maximum number of iterations for GOC
+   wfep       =  0.2      ! FeP sinking speed
+   ldocp      =  1.E-5    ! Phyto ligand production per unit doc
+   ldocz      =  1.E-5    ! Zoo ligand production per unit doc
+   lthet      =  0.5      ! Proportional loss of ligands due to Fe uptake
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -149,7 +157,9 @@
    ln_fechem =  .false.   ! complex iron chemistry ( T/F )
    ln_ligvar =  .false.   ! variable ligand concentration
+   ln_fecolloid = .false. ! variable colloidal fraction
    xlam1     =  0.005     ! scavenging rate of Iron
    xlamdust  =  150.0     ! Scavenging rate of dust
    ligand    =  0.6E-9    ! Ligands concentration 
+   kfep      =  0.        ! Nanoparticle formation rate constant
 /  
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -157,5 +167,4 @@
 !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
    xremik    =  0.3       ! remineralization rate of DOC
-   xremip    =  0.025     ! remineralisation rate of POC
    nitrif    =  0.05      ! NH4 nitrification rate
    xsirem    =  0.003     ! remineralization rate of Si
@@ -163,4 +172,14 @@
    xsilab    =  0.5       ! Fraction of labile biogenic silica
    oxymin    =  1.E-6     ! Half-saturation constant for anoxia
+   oxymin2   =  6.E-6     ! Minimum O2 concentration for oxic remin.
+   feratb    =  10.E-6    ! Fe/C quota in bacteria
+   xkferb    =  2.5E-10    ! Half-saturation constant for bacteria Fe/C
+/
+!'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
+&nampispoc     !   parameters for organic particles
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+   xremip    =  0.035     ! remineralisation rate of PON
+   jcpoc     =  15         ! Number of lability classes
+   rshape    =  1.0       ! Shape of the gamma function
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -205,4 +224,15 @@
    concfediaz  =  1.e-10   ! Diazotrophs half-saturation Cste for Iron
    hratio      =  1.e+7    ! Fe to 3He ratio assumed for vent iron supply 
+   fep_rats    =  1.       ! Fep/Fer ratio from sed sources
+   fep_rath    =  1.       ! Fep/Fer ratio from sed hydro sources
+/
+!'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
+&nampislig      !  Namelist parameters for ligands, nampislig
+!,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
+   rfep        =  0.001    ! Dissolution rate of FeP
+   rlgw        =  1.       ! Lifetime (years) of weak ligands
+   rlig        =  1.E-4    ! Remin ligand production per unit C
+   prlgw       =  1.E-4    ! Photolysis of weak ligand
+   rlgs        =  1000.    ! Lifetime (years) of strong ligands
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''