Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zagg.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zagg.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zagg.F90	(revision 7190)
@@ -128,5 +128,5 @@
                tra(ji,jj,jk,jpdop) = tra(ji,jj,jk,jpdop) - zaggdop - zaggdop2 - zaggdop3
                !
-               conspoc(ji,jj,jk) = conspoc(ji,jj,jk) - zagg + zaggdoc + zaggdoc3
+               conspoc(ji,jj,jk) = conspoc(ji,jj,jk) - zaggpoc + zaggdoc + zaggdoc3
                prodgoc(ji,jj,jk) = prodgoc(ji,jj,jk) + zaggpoc + zaggdoc2
                !
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zbio.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zbio.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zbio.F90	(revision 7190)
@@ -28,4 +28,5 @@
    USE p5zpoc          !  Remineralisation of organic particles
    USE p5zagg          !  Aggregation of particles
+   USE p4zfechem       !  Iron chemistry
    USE p4zligand       !  Remineralization of ligands
    USE prtctl_trc      !  print control for debugging
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zpoc.F90	(revision 7190)
@@ -289,5 +289,5 @@
                    END DO
                    ! Mean remineralization rate in the mixed layer
-                   zremipoc(ji,jj,jk) = MIN(xremip, MAX(0., remint ))
+                   zremipoc(ji,jj,jk) = MIN(xremipc, MAX(0., remint ))
                 ENDIF
               ENDIF
@@ -370,5 +370,5 @@
                   END DO
                   ! Mean remineralization rate in the water column
-                  zremipoc(ji,jj,jk) = MIN(xremip, MAX(0., remint ))
+                  zremipoc(ji,jj,jk) = MIN(xremipc, MAX(0., remint ))
                 ENDIF
               ENDIF
@@ -493,5 +493,5 @@
          !
          alphan(1) = gamain(reminup, rshape, ifault)
-         reminp(1) = gamain(reminup, rshape+1.0, ifault) * xremip / alphan(1)
+         reminp(1) = gamain(reminup, rshape+1.0, ifault) * xremipc / alphan(1)
          DO jn = 2, jcpoc-1
             reminup = 1./ 400. * exp(float(jn) * remindelta)
@@ -499,12 +499,13 @@
             alphan(jn) = gamain(reminup, rshape, ifault) - gamain(remindown, rshape, ifault)
             reminp(jn) = gamain(reminup, rshape+1.0, ifault) - gamain(remindown, rshape+1.0, ifault)
-            reminp(jn) = reminp(jn) * xremip / alphan(jn)
+            reminp(jn) = reminp(jn) * xremipc / alphan(jn)
          END DO
          remindown = 1. / 400. * exp(float(jcpoc-1) * remindelta)
          alphan(jcpoc) = 1.0 - gamain(remindown, rshape, ifault)
-         reminp(jcpoc) = reminp(jcpoc) * xremip / alphan(jcpoc)
+         reminp(jcpoc) = 1.0 - gamain(remindown, rshape+1.0, ifault)
+         reminp(jcpoc) = reminp(jcpoc) * xremipc / alphan(jcpoc)
       ELSE
          alphan(jcpoc) = 1.
-         reminp(jcpoc) = xremip
+         reminp(jcpoc) = xremipc
       ENDIF
 
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zprod.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zprod.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zprod.F90	(revision 7190)
@@ -90,5 +90,5 @@
       CHARACTER (len=25) :: charout
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zmixnano, zmixpico, zmixdiat, zstrn
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpislopeadn, zpislopeadp, zpislopead
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpislopeadn, zpislopeadp, zpislopeadd
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zprbio, zprpic, zprdia, zysopt
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zprchln, zprchlp, zprchld
@@ -109,5 +109,5 @@
       CALL wrk_alloc( jpi, jpj,      zmixnano, zmixpico, zmixdiat, zstrn )
       CALL wrk_alloc( jpi, jpj, jpk, zmxl_fac, zmxl_chl )
-      CALL wrk_alloc( jpi, jpj, jpk, zpislopeadn, zpislopeadp, zpislopead, zysopt ) 
+      CALL wrk_alloc( jpi, jpj, jpk, zpislopeadn, zpislopeadp, zpislopeadd, zysopt ) 
       CALL wrk_alloc( jpi, jpj, jpk, zprdia, zprpic, zprbio, zprorcan, zprorcap, zprorcad )
       CALL wrk_alloc( jpi, jpj, jpk, zprofed, zprofep, zprofen )
@@ -548,5 +548,5 @@
       !
       NAMELIST/nampisprod/ pislopen, pislopep, pisloped, xadap, bresp, excretn, excretp, excretd,  &
-         &                 thetannm, thetanpm, thetandm, chlcmin, grosip            &
+         &                 thetannm, thetanpm, thetandm, chlcmin, grosip
 
       INTEGER :: ios                 ! Local integer output status for namelist read
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zrem.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zrem.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zrem.F90	(revision 7190)
@@ -24,4 +24,5 @@
    USE p4zche          !  chemical model
    USE p5zlim          ! Phytoplankton limitation factors
+   USE p5zsink         !  Sinking of particles
    USE p5zprod         !  Production by phytoplankton
    USE prtctl_trc      !  print control for debugging
@@ -267,5 +268,4 @@
                tra(ji,jj,jk,jpgsi) = tra(ji,jj,jk,jpgsi) - zosil
                tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + zosil
-               ENDIF
             END DO
          END DO
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zsms.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zsms.F90	(revision 7189)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/P5Z/p5zsms.F90	(revision 7190)
@@ -133,5 +133,5 @@
          !
          CALL p5z_bio (kt, knt)    ! Biology
-         CALL p4z_lys( kt, jnt )   ! Compute CaCO3 saturation
+         CALL p4z_lys( kt, knt )   ! Compute CaCO3 saturation
          CALL p4z_flx( kt, knt )   ! Compute surface fluxes
          CALL p5z_sed (kt, knt)    ! Sedimentation
@@ -217,5 +217,5 @@
 #if defined key_ligand
       NAMELIST/nampisbio/ nrdttrc, wsbio, xkmort, ferat3, no3rat3, po4rat3, wsbio2,    &
-      &                   wsbio2max, wsbio2scale, niter1max, niter2max, wfep
+      &                   wsbio2max, wsbio2scale, niter1max, niter2max, wfep, ldocp, ldocz, lthet
 #else
       NAMELIST/nampisbio/ nrdttrc, wsbio, xkmort, ferat3, no3rat3, po4rat3, wsbio2,    &